Index: palm/trunk/TUTORIALS/cases/lsm_short/INPUT/lsm_short_p3d
===================================================================
--- palm/trunk/TUTORIALS/cases/lsm_short/INPUT/lsm_short_p3d	(revision 4222)
+++ palm/trunk/TUTORIALS/cases/lsm_short/INPUT/lsm_short_p3d	(revision 4397)
@@ -1,5 +1,5 @@
 !-------------------------------------------------------------------------------
 !-- INITIALIZATION PARAMETER NAMELIST
-!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/inipar
+!   https://palm.muk.uni-hannover.de/trac/wiki/doc/app/initialization_parameters
 !-------------------------------------------------------------------------------
 &initialization_parameters
@@ -29,6 +29,5 @@
                                  800.0, ! height level of temp gradients
 
-    day_of_year_init           = 232,     ! Aug 20
-    time_utc_init              = 39600.0, ! 11:00 UTC
+    origin_date_time           = '2019-08-20 11:00:00 +00'
 !
 !-- boundary conditions
@@ -43,9 +42,9 @@
     fft_method                 = 'temperton-algorithm', ! build-in fft method
 
-/ ! end of initialization parameter namelist
+/
 
 !-------------------------------------------------------------------------------
 !-- RUNTIME PARAMETER NAMELIST
-!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/d3par
+!   https://palm.muk.uni-hannover.de/trac/wiki/doc/app/runtime_parameters
 !-------------------------------------------------------------------------------
 &runtime_parameters
@@ -75,7 +74,5 @@
                                  'ghf*_xy', 'shf*_xy', 
                                  'tsurf*_xy',
-                                 't_soil',    ! 2d and/ 
-                                              ! or 3d 
-                                              ! output 
+                                 't_soil',    ! 2d and/or 3d output
 
     data_output_pr             = '#u', '#v', '#theta',
@@ -84,6 +81,5 @@
                                  'w"theta"', 'w*theta*', 'wtheta', 'w*e*', 
                                  'theta*2','u*2', 'v*2', 'w*2', 
-                                 '#t_soil',                        ! Profile 
-                                                                   ! output
+                                 '#t_soil',   ! Profile output
 
     section_xy                 = 0, ! grid index for 2D XY cross sections
@@ -95,9 +91,9 @@
     dt_averaging_input_pr      =   6.0, ! averaging profile data sampling rate
 
-/ ! end of runtime parameter namelist
+/
 
 !-------------------------------------------------------------------------------
 !-- LAND-SURFACE PARAMETER NAMELIST
-!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/lsmpar
+!   https://palm.muk.uni-hannover.de/trac/wiki/doc/app/land_surface_parameters
 !-------------------------------------------------------------------------------
 &land_surface_parameters
@@ -112,22 +108,23 @@
     vegetation_type            = 1, ! vegetation to be used in surface model
 
-/ ! end of land-surface parameter namelist
+/
 
 !-------------------------------------------------------------------------------
 !-- RADIATION PARAMETER NAMELIST
-!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/radpar
+!   https://palm.muk.uni-hannover.de/trac/wiki/doc/app/radiation_parameters
 !-------------------------------------------------------------------------------
 &radiation_parameters
-    radiation_scheme           = 'clear-sky', ! Radiation scheme to be used
+    radiation_scheme           = 'constant', ! Radiation scheme to be used
+    net_radiation              = 800.0, !
     dt_radiation               = 20.0, ! Time step of the radiation model
 
-/ ! end of radiation parameter namelist
+/
 
 !-------------------------------------------------------------------------------
 !-- USER PARAMETER NAMELIST
-!   Documentation: https://palm.muk.uni-hannover.de/trac/wiki/doc/app/userpar
+!   https://palm.muk.uni-hannover.de/trac/wiki/doc/app/user_parameters
 !-------------------------------------------------------------------------------
 &user_parameters
-    data_output_user           = 'v_h', 'v_h_xy', ! user defined data output
+    data_output_user           = 'v_h', ! user defined data output
 
-/ ! end of user parameter namelist
+/