Index: palm/trunk/TUTORIALS/cases/lsm_short/INPUT/lsm_short_p3d
===================================================================
--- palm/trunk/TUTORIALS/cases/lsm_short/INPUT/lsm_short_p3d	(revision 4397)
+++ palm/trunk/TUTORIALS/cases/lsm_short/INPUT/lsm_short_p3d	(revision 4409)
@@ -24,8 +24,6 @@
     pt_surface                 = 293.0, ! initial surface potential temp
 
-    pt_vertical_gradient       = 0.0,
-                                 2.0, ! piecewise temp gradients
-    pt_vertical_gradient_level = 0.0,
-                                 800.0, ! height level of temp gradients
+    pt_vertical_gradient       = 0.0, 2.0, ! piecewise temp gradients
+    pt_vertical_gradient_level = 0.0, 800.0, ! height level of temp gradients
 
     origin_date_time           = '2019-08-20 11:00:00 +00'
@@ -70,16 +68,7 @@
     dt_do2d_xy                 = 60.0,   ! output interval for 2d-xy data
 
-    data_output                = 'theta', 'w', 'u', 'v',
-                                 'us*_xy', 
-                                 'ghf*_xy', 'shf*_xy', 
-                                 'tsurf*_xy',
-                                 't_soil',    ! 2d and/or 3d output
+    data_output                = 'theta', 'w', 'u', 'v', 'us*_xy', 'ghf*_xy', 'shf*_xy', 'tsurf*_xy', 't_soil',    ! 2d and/or 3d output
 
-    data_output_pr             = '#u', '#v', '#theta',
-                                 '#km', '#kh', '#l',
-                                 'w', 'e', 'e*', 'p',
-                                 'w"theta"', 'w*theta*', 'wtheta', 'w*e*', 
-                                 'theta*2','u*2', 'v*2', 'w*2', 
-                                 '#t_soil',   ! Profile output
+    data_output_pr             = '#u', '#v', '#theta', '#km', '#kh', '#l', 'w', 'e', 'e*', 'p', 'w"theta"', 'w*theta*', 'wtheta', 'w*e*', 'theta*2','u*2', 'v*2', 'w*2', '#t_soil',   ! Profile output
 
     section_xy                 = 0, ! grid index for 2D XY cross sections
@@ -99,8 +88,6 @@
 &land_surface_parameters
     soil_type                  = 3,  ! type to be used in soil model
-    soil_moisture              = 0.0,   0.0,   0.0,   0.0, ! moisture at every
-                                 0.0,   0.0,   0.0,   0.0, ! soil level
-    soil_temperature           = 293,   293,   293,   293, ! temperature at
-                                 293,   293,   293,   293, ! every soil level
+    soil_moisture              = 0.0,   0.0,   0.0,   0.0, 0.0,   0.0,   0.0,   0.0,
+    soil_temperature           = 293,   293,   293,   293, 293,   293,   293,   293, ! every soil level
     deep_soil_temperature      = 293,  ! temperature of deep soil
 
Index: palm/trunk/TUTORIALS/cases/lsm_short/MONITORING/lsm_short_rc
===================================================================
--- palm/trunk/TUTORIALS/cases/lsm_short/MONITORING/lsm_short_rc	(revision 4397)
+++ palm/trunk/TUTORIALS/cases/lsm_short/MONITORING/lsm_short_rc	(revision 4409)
@@ -1,10 +1,10 @@
 
  ******************************    --------------------------------------------
- * PALM 6.0  Rev: 4389        *    atmosphere - run without 1D - prerun
+ * PALM 6.0  Rev: 4402        *    atmosphere - run without 1D - prerun
  ******************************    --------------------------------------------
 
- Date:               2020-02-07    Run:       lsm_short                         
- Time:                 16:26:56    Run-No.:   00
- Run on host:             r4389
+ Date:               2020-02-14    Run:       lsm_short__gfortran_default__4    
+ Time:                 11:14:41    Run-No.:   00
+ Run on host:        gfortran_d
  Number of PEs:               4    Processor grid (x,y): (   2,   2) calculated
  ------------------------------------------------------------------------------
@@ -311,5 +311,5 @@
   0    611 00:56:03.39   3.5300A   3.4932  -3.8873   6.3763  0.121  2.20  -0.310E+01    925.  0.655E+00  0.650E+00  0.308E-03  0.292E-13    1   3   9   37  30  29   30  32  29    0.000    0.000       0
   0    627 00:57:00.97   3.5400A  -3.0215  -3.8977   6.3630  0.120  2.18  -0.306E+01    900.  0.662E+00  0.657E+00  0.308E-03  0.294E-13   31  13   8   38  27  30   27  15  21    0.000    0.000       0
-  0    643 00:58:00.99   3.8200A  -3.1488   3.6349   5.8895  0.119  2.20  -0.309E+01    925.  0.662E+00  0.659E+00  0.342E-03  0.331E-13   38  33  22   21  35   1   18  27   9    0.000    0.000       0
+  0    643 00:58:00.99   3.8200A  -3.1488   3.6350   5.8895  0.119  2.20  -0.309E+01    925.  0.662E+00  0.659E+00  0.342E-03  0.331E-13   38  33  22   21  35   1   18  27   9    0.000    0.000       0
   0    659 00:59:02.72   3.9000A  -3.0297  -3.5710   5.7698  0.120  2.19  -0.308E+01    900.  0.663E+00  0.660E+00  0.351E-03  0.338E-13   33  11   7   16   2  38   32  26   6    0.000    0.000       0
   0    674 01:00:01.39   3.8800A   3.4608   3.5710   5.7932  0.121  2.15  -0.309E+01    850.  0.666E+00  0.664E+00  0.354E-03  0.336E-13   17  19  29   26  33   4   18  11  20    0.000    0.000       0
@@ -329,47 +329,47 @@
   0    898 01:14:02.30   3.6800A   3.6534  -3.7072   6.1220  0.132  2.29  -0.314E+01    925.  0.819E+00  0.815E+00  0.372E-03  0.347E-13   27   6  28   37  29  36   21   2  20    0.000    0.000       0
   0    915 01:15:02.84   3.4300A   3.7497  -3.8179   6.5666  0.132  2.27  -0.316E+01    900.  0.844E+00  0.839E+00  0.363E-03  0.332E-13   28   6  30    1  13  24   21  13  10    0.000    0.000       0
-  0    933 01:16:01.69   3.3500A   3.5353  -4.1565   6.7211  0.130  2.29  -0.318E+01    925.  0.866E+00  0.861E+00  0.359E-03  0.324E-13   24  10  11    2  12  24   31  38  38    0.000    0.000       0
+  0    933 01:16:01.69   3.3500A   3.5352  -4.1565   6.7211  0.130  2.29  -0.318E+01    925.  0.866E+00  0.861E+00  0.359E-03  0.324E-13   24  10  11    2  12  24   31  38  38    0.000    0.000       0
   0    950 01:17:01.39   3.4800A  -3.8042  -4.0536   6.4733  0.129  2.35  -0.320E+01   1000.  0.888E+00  0.883E+00  0.378E-03  0.344E-13    9  11  24    2  11  24   22  37  14    0.000    0.000       0
   0    968 01:18:02.70   3.4500A   4.2935  -3.9053   6.5190  0.129  2.33  -0.321E+01    975.  0.897E+00  0.894E+00  0.371E-03  0.342E-13   29  11  12    1   6  23   31  38  15    0.000    0.000       0
   0    985 01:19:01.26   3.6800A   3.9624  -4.1758   6.1135  0.130  2.29  -0.320E+01    925.  0.909E+00  0.905E+00  0.397E-03  0.364E-13   34  11  13    1   5  22   33   0  16    0.000    0.000       0
   0   1001 01:20:00.04   3.6900A  -4.1990  -4.5214   6.0971  0.130  2.26  -0.321E+01    875.  0.901E+00  0.895E+00  0.417E-03  0.383E-13    1   4  24    2   4  22   19  23  29    0.000    0.000       0
-  0   1018 01:21:03.35   3.7400A  -3.8122  -4.5139   6.0204  0.131  2.28  -0.323E+01    900.  0.893E+00  0.886E+00  0.432E-03  0.391E-13    1   4  23    2   3  21   26  22  30    0.000    0.000       0
-  0   1034 01:22:03.87   3.9100A  -4.3708  -4.1756   5.7586  0.130  2.30  -0.323E+01    925.  0.888E+00  0.880E+00  0.445E-03  0.402E-13    1   3  23    2   2  21   33  21  30    0.000    0.000       0
-  0   1050 01:23:03.32   3.7000A   4.1323  -4.3211   6.0869  0.129  2.34  -0.324E+01    975.  0.895E+00  0.887E+00  0.422E-03  0.385E-13   27   1  27    2   2  20   24  24  26    0.000    0.000       0
-  0   1065 01:24:00.31   3.7500A  -4.4516  -3.9578   5.9974  0.131  2.35  -0.324E+01    975.  0.893E+00  0.885E+00  0.433E-03  0.395E-13    1   2  21    1   2  19   28   5  10    0.000    0.000       0
-  0   1081 01:25:00.62   3.6900A  -3.8178  -3.4814   6.1008  0.134  2.32  -0.321E+01    925.  0.888E+00  0.879E+00  0.438E-03  0.396E-13    8   1  20    4   3   9   29   5  10    0.000    0.000       0
-  0   1097 01:26:00.72   4.2300A  -4.0594  -3.4139   5.3218  0.136  2.37  -0.321E+01    975.  0.881E+00  0.872E+00  0.479E-03  0.430E-13    1   1  26   25  35  15   36   5  10    0.000    0.000       0
-  0   1112 01:27:02.30   3.7300A  -4.1025  -3.7795   6.0273  0.139  2.36  -0.317E+01    950.  0.877E+00  0.869E+00  0.429E-03  0.380E-13    1   2  25   27  33  15   18  21  25    0.000    0.000       0
-  0   1127 01:28:00.43   3.8400A  -4.1136  -4.3535   5.8627  0.144  2.34  -0.316E+01    900.  0.895E+00  0.889E+00  0.455E-03  0.399E-13    1   2  23   17  38   9   19  38  17    0.000    0.000       0
-  0   1143 01:29:00.85   3.7900A   4.2106  -3.9930   5.9385  0.146  2.39  -0.316E+01    950.  0.926E+00  0.921E+00  0.446E-03  0.386E-13   34   1  23   24  37   8   29  36  18    0.000    0.000       0
-  0   1158 01:30:01.54   4.1900A  -4.2571  -3.6347   5.3674  0.146  2.45  -0.313E+01   1025.  0.951E+00  0.947E+00  0.497E-03  0.425E-13   35  36   9   35  35  11   32  35   9    0.000    0.000       0
-  0   1173 01:31:01.98   3.8000A  -4.0654  -4.1399   5.9174  0.145  2.42  -0.316E+01   1000.  0.983E+00  0.980E+00  0.465E-03  0.397E-13   38  35   7   16  12  10   11   2   8    0.000    0.000       0
-  0   1191 01:32:01.05   2.9900A   3.9583  -4.3964   7.5210  0.143  2.40  -0.314E+01    975.  0.103E+01  0.103E+01  0.359E-03  0.310E-13   39  32  24   30  34   8   20   3   9    0.000    0.000       0
-  0   1211 01:33:00.13   3.1200A  -4.9115  -5.0013   7.2118  0.142  2.45  -0.313E+01   1050.  0.107E+01  0.106E+01  0.371E-03  0.323E-13   38   0   4   34  31   5   31   3   9    0.000    0.000       0
-  0   1230 01:34:02.71   3.1600A  -5.0792  -5.0443   7.1128  0.141  2.45  -0.314E+01   1050.  0.109E+01  0.108E+01  0.392E-03  0.342E-13   39  39   1   37  29  11   24   2  17    0.000    0.000       0
-  0   1248 01:35:00.59   3.1600A   4.7974  -4.5539   7.1103  0.142  2.40  -0.314E+01    975.  0.112E+01  0.110E+01  0.397E-03  0.345E-13   36   2  21   36  26  10   24   1  17    0.000    0.000       0
-  0   1268 01:36:01.01   2.8400A   5.0592  -4.3078   7.9169  0.142  2.38  -0.316E+01    950.  0.114E+01  0.112E+01  0.365E-03  0.320E-13   40   2  24   41  31   3   28  26  18    0.000    0.000       0
-  0   1290 01:37:01.62   2.7800A   4.1699  -4.2981   8.0893  0.142  2.42  -0.319E+01   1000.  0.115E+01  0.112E+01  0.352E-03  0.309E-13   43   3  25   39  38  16   34  27  18    0.000    0.000       0
-  0   1311 01:38:02.10   3.1200A  -4.5467  -4.3807   7.2075  0.142  2.44  -0.318E+01   1025.  0.114E+01  0.112E+01  0.387E-03  0.348E-13   42  24  14   41  20  17   29   3  17    0.000    0.000       0
-  0   1331 01:39:00.09   2.8600A  -4.6851  -3.8138   7.8599  0.143  2.43  -0.317E+01   1000.  0.113E+01  0.112E+01  0.372E-03  0.335E-13   44  25  13   42  18  16   36   3  17    0.000    0.000       0
-  0   1352 01:40:00.10   3.0100A  -4.8544   4.2130   7.4670  0.146  2.48  -0.314E+01   1050.  0.111E+01  0.110E+01  0.408E-03  0.361E-13   44  29  13   45  32  16   36  30  15    0.000    0.000       0
-  0   1371 01:41:02.28   3.6700A  -5.1985   3.5993   6.1244  0.147  2.44  -0.314E+01   1000.  0.108E+01  0.107E+01  0.481E-03  0.430E-13   41  29  10   42  12  22   20  25  25    0.000    0.000       0
-  0   1387 01:42:00.90   3.6100A  -4.7303   4.0113   6.2244  0.147  2.42  -0.314E+01    975.  0.106E+01  0.105E+01  0.463E-03  0.411E-13   41  31   7   41  10  16   15  25  13    0.000    0.000       0
-  0   1404 01:43:02.02   3.5000A  -5.0748   3.4622   6.4334  0.144  2.41  -0.317E+01    975.  0.107E+01  0.106E+01  0.440E-03  0.381E-13   34  29   9    1  27  21   29  24  15    0.000    0.000       0
-  0   1421 01:44:01.75   3.3400A  -4.3921  -3.7044   6.7418  0.137  2.46  -0.324E+01   1075.  0.109E+01  0.108E+01  0.430E-03  0.367E-13   34  30   5   35  22  12   23  32  20    0.000    0.000       0
-  0   1440 01:45:00.58   2.9200A  -4.2329  -3.7033   7.6981  0.132  2.41  -0.329E+01   1025.  0.109E+01  0.108E+01  0.381E-03  0.326E-13   32  30  10   40  19  12   25  30  18    0.000    0.000       0
-  0   1461 01:46:02.85   3.1100A  -4.4854  -3.8286   7.2272  0.130  2.38  -0.334E+01   1000.  0.110E+01  0.109E+01  0.401E-03  0.348E-13   40  32  10   44  30  17   34  30  18    0.000    0.000       0
-  0   1480 01:47:02.67   3.3000A  -5.7457   3.9496   6.8107  0.129  2.44  -0.342E+01   1075.  0.108E+01  0.107E+01  0.428E-03  0.376E-13   39  32   7   34  30   9   33  30  18    0.000    0.000       0
-  0   1498 01:48:02.50   3.0900A  -5.0626   3.8742   7.2865  0.130  2.37  -0.342E+01    975.  0.105E+01  0.104E+01  0.405E-03  0.354E-13   38  33   4    1  30  30   20  30  15    0.000    0.000       0
-  0   1517 01:49:01.16   3.0900A  -4.6494   4.1860   7.2912  0.134  2.37  -0.343E+01    950.  0.103E+01  0.102E+01  0.407E-03  0.344E-13   36  34   1   39  38  21   33  31  15    0.000    0.000       0
-  0   1536 01:50:02.44   3.6200A   4.1668   4.2134   6.2197  0.142  2.35  -0.329E+01    900.  0.101E+01  0.101E+01  0.472E-03  0.400E-13   12   3   7    1  33  32   32   4  15    0.000    0.000       0
-  0   1553 01:51:02.60   3.2300A   3.9086  -3.5874   6.9765  0.147  2.48  -0.325E+01   1025.  0.101E+01  0.100E+01  0.420E-03  0.353E-13   17   4   7   40  24  15   21  33  28    0.000    0.000       0
-  0   1572 01:52:01.02   2.9900A  -3.8146  -3.6533   7.5192  0.150  2.49  -0.321E+01   1025.  0.101E+01  0.100E+01  0.382E-03  0.315E-13   44  28  11   34   0  11   31  33  28    0.000    0.000       0
-  0   1592 01:53:01.67   3.1800A   3.8179   3.6630   7.0760  0.148  2.44  -0.321E+01    975.  0.101E+01  0.100E+01  0.410E-03  0.337E-13    1  35  11   44  38  27   40  34  27    0.000    0.000       0
-  0   1610 01:54:01.93   3.3100A   4.3994  -3.4200   6.8034  0.144  2.38  -0.325E+01    925.  0.101E+01  0.100E+01  0.445E-03  0.366E-13    1  35  13   44  28  27   28  35  21    0.000    0.000       0
-  0   1630 01:55:02.52   2.9500A   4.2608  -3.9015   7.6364  0.141  2.39  -0.329E+01    950.  0.104E+01  0.103E+01  0.392E-03  0.322E-13   18   2  21   15   6  19   32  28  13    0.000    0.000       0
-  0   1648 01:56:01.12   3.4800A   4.8720   4.2349   6.4659  0.138  2.34  -0.334E+01    900.  0.106E+01  0.105E+01  0.465E-03  0.387E-13   21   2  23   38   2  24   36  29  14    0.000    0.000       0
-  0   1665 01:57:00.54   3.3900A   3.7311   4.2020   6.6358  0.134  2.45  -0.341E+01   1050.  0.107E+01  0.106E+01  0.461E-03  0.382E-13   29   4  23   29   7  20   34  27  11    0.000    0.000       0
-  0   1684 01:58:01.74   3.1800A   4.1653   4.2029   7.0743  0.131  2.40  -0.345E+01   1000.  0.109E+01  0.108E+01  0.432E-03  0.356E-13   32   5  26   44   0  19   24   7  19    0.000    0.000       0
-  0   1703 01:59:02.09   3.4800A   4.6605   3.7619   6.4691  0.129  2.47  -0.347E+01   1100.  0.107E+01  0.106E+01  0.462E-03  0.387E-13   18  22  13   15   3  36   31  32  20    0.000    0.000       0
-  0   1720 02:00:02.05   3.3800A   3.9150   3.9364   6.6536  0.129  2.40  -0.345E+01   1000.  0.106E+01  0.106E+01  0.467E-03  0.385E-13   41  30  23   38  39  17   19  37  21    0.000    0.000       0
+  0   1018 01:21:03.35   3.7400A  -3.8121  -4.5139   6.0204  0.131  2.28  -0.323E+01    900.  0.893E+00  0.886E+00  0.432E-03  0.391E-13    1   4  23    2   3  21   26  22  30    0.000    0.000       0
+  0   1034 01:22:03.87   3.9100A  -4.3708  -4.1757   5.7585  0.130  2.30  -0.323E+01    925.  0.888E+00  0.880E+00  0.445E-03  0.402E-13    1   3  23    2   2  21   33  21  30    0.000    0.000       0
+  0   1050 01:23:03.32   3.7000A   4.1322  -4.3210   6.0868  0.129  2.34  -0.324E+01    975.  0.895E+00  0.887E+00  0.422E-03  0.385E-13   27   1  27    2   2  20   24  24  26    0.000    0.000       0
+  0   1065 01:24:00.31   3.7500A  -4.4515  -3.9577   5.9974  0.131  2.35  -0.324E+01    975.  0.893E+00  0.885E+00  0.433E-03  0.395E-13    1   2  21    1   2  19   28   5  10    0.000    0.000       0
+  0   1081 01:25:00.62   3.6900A  -3.8178  -3.4814   6.1009  0.134  2.32  -0.321E+01    925.  0.888E+00  0.879E+00  0.438E-03  0.396E-13    8   1  20    4   3   9   29   5  10    0.000    0.000       0
+  0   1097 01:26:00.72   4.2300A  -4.0595  -3.4137   5.3217  0.136  2.37  -0.321E+01    975.  0.881E+00  0.872E+00  0.479E-03  0.430E-13    1   1  26   25  35  15   36   5  10    0.000    0.000       0
+  0   1112 01:27:02.31   3.7300A  -4.1024  -3.7793   6.0274  0.139  2.36  -0.317E+01    950.  0.877E+00  0.869E+00  0.429E-03  0.380E-13    1   2  25   27  33  15   18  21  25    0.000    0.000       0
+  0   1127 01:28:00.44   3.8400A  -4.1132  -4.3536   5.8628  0.144  2.34  -0.316E+01    900.  0.895E+00  0.889E+00  0.455E-03  0.399E-13    1   2  23   17  38   9   19  38  17    0.000    0.000       0
+  0   1143 01:29:00.87   3.7900A   4.2107  -3.9932   5.9380  0.146  2.39  -0.316E+01    950.  0.926E+00  0.921E+00  0.446E-03  0.386E-13   34   1  23   24  37   8   29  36  18    0.000    0.000       0
+  0   1158 01:30:01.55   4.1900A  -4.2576  -3.6350   5.3679  0.146  2.45  -0.313E+01   1025.  0.951E+00  0.947E+00  0.497E-03  0.425E-13   35  36   9   35  35  11   32  35   9    0.000    0.000       0
+  0   1173 01:31:01.99   3.8000A  -4.0657  -4.1395   5.9181  0.145  2.42  -0.316E+01   1000.  0.983E+00  0.980E+00  0.465E-03  0.397E-13   38  35   7   16  12  10   11   2   8    0.000    0.000       0
+  0   1191 01:32:01.06   2.9900A   3.9585  -4.3963   7.5211  0.143  2.40  -0.314E+01    975.  0.103E+01  0.103E+01  0.359E-03  0.310E-13   39  32  24   30  34   8   20   3   9    0.000    0.000       0
+  0   1211 01:33:00.15   3.1200A  -4.9115  -5.0019   7.2108  0.142  2.45  -0.313E+01   1050.  0.107E+01  0.106E+01  0.371E-03  0.323E-13   38   0   4   34  31   5   31   3   9    0.000    0.000       0
+  0   1230 01:34:02.73   3.1600A  -5.0792  -5.0448   7.1132  0.141  2.45  -0.314E+01   1050.  0.109E+01  0.108E+01  0.392E-03  0.342E-13   39  39   1   37  29  11   24   2  17    0.000    0.000       0
+  0   1248 01:35:00.62   3.1600A   4.7965  -4.5551   7.1103  0.142  2.40  -0.314E+01    975.  0.112E+01  0.110E+01  0.398E-03  0.346E-13   36   2  21   36  26  10   24   1  17    0.000    0.000       0
+  0   1268 01:36:01.04   2.8400A   5.0566  -4.3069   7.9208  0.142  2.38  -0.316E+01    950.  0.114E+01  0.112E+01  0.365E-03  0.320E-13   40   2  24   41  31   3   28  26  18    0.000    0.000       0
+  0   1290 01:37:01.63   2.7800A   4.1688  -4.3049   8.0935  0.142  2.42  -0.319E+01   1000.  0.115E+01  0.112E+01  0.352E-03  0.309E-13   43   3  25   39  38  16   34  27  18    0.000    0.000       0
+  0   1311 01:38:02.08   3.1200A  -4.5463  -4.3848   7.2076  0.142  2.44  -0.318E+01   1025.  0.114E+01  0.112E+01  0.387E-03  0.348E-13   42  24  14   41  20  17   29   3  17    0.000    0.000       0
+  0   1331 01:39:00.07   2.8600A  -4.6898  -3.8181   7.8612  0.143  2.43  -0.317E+01   1000.  0.113E+01  0.112E+01  0.372E-03  0.335E-13   44  25  13   42  18  16   36   3  17    0.000    0.000       0
+  0   1352 01:40:00.07   3.0100A  -4.8562   4.2191   7.4706  0.146  2.48  -0.314E+01   1050.  0.111E+01  0.110E+01  0.408E-03  0.361E-13   44  29  13   45  32  16   36  30  15    0.000    0.000       0
+  0   1371 01:41:02.28   3.6700A  -5.2011   3.5977   6.1234  0.147  2.44  -0.314E+01   1000.  0.108E+01  0.107E+01  0.481E-03  0.430E-13   41  29  10   42  12  22   20  25  25    0.000    0.000       0
+  0   1387 01:42:00.91   3.6100A  -4.7229   4.0121   6.2254  0.147  2.42  -0.314E+01    975.  0.106E+01  0.105E+01  0.463E-03  0.411E-13   41  31   7   41  10  16   15  25  13    0.000    0.000       0
+  0   1404 01:43:02.04   3.5000A  -5.0764   3.4659   6.4262  0.144  2.41  -0.317E+01    975.  0.107E+01  0.106E+01  0.440E-03  0.381E-13   34  29   9    1  27  21   29  24  15    0.000    0.000       0
+  0   1421 01:44:01.81   3.3400A  -4.3755  -3.6993   6.7441  0.137  2.46  -0.324E+01   1075.  0.109E+01  0.108E+01  0.430E-03  0.367E-13   34  30   5   35  22  12   23  32  20    0.000    0.000       0
+  0   1440 01:45:00.65   2.9200A  -4.2136  -3.6976   7.6976  0.132  2.41  -0.329E+01   1025.  0.109E+01  0.108E+01  0.381E-03  0.326E-13   32  28  11   40  19  12   25  30  18    0.000    0.000       0
+  0   1461 01:46:02.89   3.1100A  -4.4747  -3.8814   7.2275  0.130  2.38  -0.334E+01   1000.  0.110E+01  0.109E+01  0.401E-03  0.348E-13   40  32  10   44  30  17   34  30  18    0.000    0.000       0
+  0   1480 01:47:02.71   3.3000A  -5.7419   3.9887   6.8194  0.129  2.44  -0.342E+01   1075.  0.108E+01  0.107E+01  0.428E-03  0.376E-13   39  32   7   34  30   9   33  30  18    0.000    0.000       0
+  0   1498 01:48:02.32   3.0600A  -5.1730   3.8710   7.3581  0.130  2.37  -0.342E+01    975.  0.105E+01  0.104E+01  0.402E-03  0.351E-13   38  33   4    1  30  30   20  30  15    0.000    0.000       0
+  0   1517 01:49:00.43   3.0700A  -4.6641   4.1815   7.3345  0.134  2.37  -0.339E+01    950.  0.103E+01  0.102E+01  0.404E-03  0.342E-13   37  34   1   39  38  21   33  31  15    0.000    0.000       0
+  0   1536 01:50:01.30   3.6100A   4.1902   4.2292   6.2258  0.141  2.35  -0.329E+01    900.  0.101E+01  0.101E+01  0.471E-03  0.399E-13   12   3   7    1  33  31   32   4  15    0.000    0.000       0
+  0   1553 01:51:01.13   3.2300A   3.9049  -3.6179   6.9573  0.147  2.40  -0.325E+01    925.  0.101E+01  0.100E+01  0.421E-03  0.354E-13   17   4   7    1   0  26   21  33  28    0.000    0.000       0
+  0   1573 01:52:02.53   2.9900A  -3.8620  -3.6876   7.5304  0.150  2.49  -0.322E+01   1025.  0.101E+01  0.100E+01  0.383E-03  0.315E-13   43  29  10   34   0  11   32  33  28    0.000    0.000       0
+  0   1592 01:53:00.20   3.1600A   3.7698   3.6672   7.1142  0.148  2.29  -0.321E+01    800.  0.101E+01  0.100E+01  0.408E-03  0.335E-13    1  35  11   44  38  27   38  33  28    0.000    0.000       0
+  0   1611 01:54:03.23   3.2500A   4.3997   3.4270   6.9161  0.144  2.38  -0.326E+01    925.  0.101E+01  0.100E+01  0.438E-03  0.361E-13    1  35  13   37   0  24   28  35  21    0.000    0.000       0
+  0   1630 01:55:01.76   2.9600A   4.2012  -3.8586   7.5911  0.141  2.39  -0.329E+01    950.  0.104E+01  0.103E+01  0.400E-03  0.328E-13   18   2  21   15   6  19   31  28  13    0.000    0.000       0
+  0   1648 01:56:01.11   3.4800A   4.9521   3.9985   6.4697  0.138  2.34  -0.335E+01    900.  0.106E+01  0.106E+01  0.462E-03  0.383E-13   21   2  23   38   2  24   32  35  22    0.000    0.000       0
+  0   1665 01:57:00.84   3.4600A   3.9706   4.2439   6.4952  0.134  2.37  -0.339E+01    950.  0.107E+01  0.106E+01  0.469E-03  0.389E-13   28   4  23   29   7  20   33  27  11    0.000    0.000       0
+  0   1684 01:58:02.96   3.1500A   4.0927   4.1890   7.1317  0.131  2.40  -0.342E+01   1000.  0.109E+01  0.108E+01  0.424E-03  0.350E-13   31   5  25   46   2  20   26   7  19    0.000    0.000       0
+  0   1702 01:59:00.62   3.2700A   3.8317  -3.5119   6.8745  0.129  2.47  -0.346E+01   1100.  0.107E+01  0.107E+01  0.447E-03  0.372E-13   17  22  12    1   6  22   33   8  18    0.000    0.000       0
+  0   1720 02:00:01.87   3.2800A  -3.7534   3.9650   6.8552  0.128  2.40  -0.347E+01   1000.  0.107E+01  0.106E+01  0.454E-03  0.376E-13    8   4  22   37  14  17   28  36  19    0.000    0.000       0